// ignore_for_file: non_constant_identifier_names
// ignore_for_file: camel_case_types
// ignore_for_file: prefer_single_quotes

// This file is automatically generated. DO NOT EDIT, all your changes would be lost.
import 'package:flutter/material.dart' show debugPrint;
import 'package:saveappforios/domain/BillAmount.dart';
import 'package:saveappforios/domain/Body.dart';
import 'package:saveappforios/domain/CountryData.dart';
import 'package:saveappforios/domain/CountryList.dart';
import 'package:saveappforios/domain/Feedbackdata.dart';
import 'package:saveappforios/domain/Feedbackfulldata.dart';
import 'package:saveappforios/domain/Head.dart';
import 'package:saveappforios/domain/InvoiceData.dart';
import 'package:saveappforios/domain/Message.dart';
import 'package:saveappforios/domain/MessageData.dart';
import 'package:saveappforios/domain/NetworkDashboard.dart';
import 'package:saveappforios/domain/NetworkDashboardData.dart';
import 'package:saveappforios/domain/NetworkSlider.dart';
import 'package:saveappforios/domain/NetworkSliderData.dart';
import 'package:saveappforios/domain/NotificationMessage.dart';
import 'package:saveappforios/domain/Profile.dart';
import 'package:saveappforios/domain/Profiledata.dart';
import 'package:saveappforios/domain/RemindDateOfAsset.dart';
import 'package:saveappforios/domain/ResultInfo.dart';
import 'package:saveappforios/domain/SalesInfo.dart';
import 'package:saveappforios/domain/SalesinfoData.dart';
import 'package:saveappforios/domain/SettingsData.dart';
import 'package:saveappforios/domain/ShareSlider.dart';
import 'package:saveappforios/domain/ShareSliderData.dart';
import 'package:saveappforios/domain/StateData.dart';
import 'package:saveappforios/domain/Statelist.dart';
import 'package:saveappforios/domain/Tokendata.dart';
import 'package:saveappforios/domain/bill_entity.dart';
import 'package:saveappforios/domain/country_single_data_entity.dart';
import 'package:saveappforios/domain/coupon_data_entity.dart';

JsonConvert jsonConvert = JsonConvert();
typedef JsonConvertFunction<T> = T Function(Map<String, dynamic> json);

class JsonConvert {
	static final Map<String, JsonConvertFunction> _convertFuncMap = {
		(BillAmount).toString(): BillAmount.fromJson,
		(Body).toString(): Body.fromJson,
		(CountryData).toString(): CountryData.fromJson,
		(CountryList).toString(): CountryList.fromJson,
		(FeedbackList).toString(): FeedbackList.fromJson,
		(FeedbackFulldata).toString(): FeedbackFulldata.fromJson,
		(Head).toString(): Head.fromJson,
		(InvoiceData).toString(): InvoiceData.fromJson,
		(Message).toString(): Message.fromJson,
		(MessageData).toString(): MessageData.fromJson,
		(NetworkDashboard).toString(): NetworkDashboard.fromJson,
		(NetWorkDashboardData).toString(): NetWorkDashboardData.fromJson,
		(NetworkSlider).toString(): NetworkSlider.fromJson,
		(NetworkSliderData).toString(): NetworkSliderData.fromJson,
		(NotificationMessage).toString(): NotificationMessage.fromJson,
		(Profile).toString(): Profile.fromJson,
		(Profiledata).toString(): Profiledata.fromJson,
		(RemindDateofAsset).toString(): RemindDateofAsset.fromJson,
		(ResultInfo).toString(): ResultInfo.fromJson,
		(Salesinfo).toString(): Salesinfo.fromJson,
		(SalesinfoData).toString(): SalesinfoData.fromJson,
		(SettingsData).toString(): SettingsData.fromJson,
		(ShareSlider).toString(): ShareSlider.fromJson,
		(ShareSliderData).toString(): ShareSliderData.fromJson,
		(StateData).toString(): StateData.fromJson,
		(Statelist).toString(): Statelist.fromJson,
		(Tokendata).toString(): Tokendata.fromJson,
		(BillEntity).toString(): BillEntity.fromJson,
		(BillData).toString(): BillData.fromJson,
		(CountrySingleDataEntity).toString(): CountrySingleDataEntity.fromJson,
		(CountrySingleDataData).toString(): CountrySingleDataData.fromJson,
		(CouponDataEntity).toString(): CouponDataEntity.fromJson,
		(CouponDataData).toString(): CouponDataData.fromJson,
	};

  T? convert<T>(dynamic value) {
    if (value == null) {
      return null;
    }
    return asT<T>(value);
  }

  List<T?>? convertList<T>(List<dynamic>? value) {
    if (value == null) {
      return null;
    }
    try {
      return value.map((dynamic e) => asT<T>(e)).toList();
    } catch (e, stackTrace) {
      debugPrint('asT<$T> $e $stackTrace');
      return <T>[];
    }
  }

  List<T>? convertListNotNull<T>(dynamic value) {
    if (value == null) {
      return null;
    }
    try {
      return (value as List<dynamic>).map((dynamic e) => asT<T>(e)!).toList();
    } catch (e, stackTrace) {
      debugPrint('asT<$T> $e $stackTrace');
      return <T>[];
    }
  }

  T? asT<T extends Object?>(dynamic value) {
    if (value is T) {
      return value;
    }
    final String type = T.toString();
    try {
      final String valueS = value.toString();
      if (type == "String") {
        return valueS as T;
      } else if (type == "int") {
        final int? intValue = int.tryParse(valueS);
        if (intValue == null) {
          return double.tryParse(valueS)?.toInt() as T?;
        } else {
          return intValue as T;
        }
      } else if (type == "double") {
        return double.parse(valueS) as T;
      } else if (type == "DateTime") {
        return DateTime.parse(valueS) as T;
      } else if (type == "bool") {
        if (valueS == '0' || valueS == '1') {
          return (valueS == '1') as T;
        }
        return (valueS == 'true') as T;
      } else if (type == "Map" || type.startsWith("Map<")) {
        return value as T;
      } else {
        if (_convertFuncMap.containsKey(type)) {
          return _convertFuncMap[type]!(value) as T;
        } else {
          throw UnimplementedError('$type unimplemented');
        }
      }
    } catch (e, stackTrace) {
      debugPrint('asT<$T> $e $stackTrace');
      return null;
    }
  }

	//list is returned by type
	static M? _getListChildType<M>(List<Map<String, dynamic>> data) {
		if(<BillAmount>[] is M){
			return data.map<BillAmount>((Map<String, dynamic> e) => BillAmount.fromJson(e)).toList() as M;
		}
		if(<Body>[] is M){
			return data.map<Body>((Map<String, dynamic> e) => Body.fromJson(e)).toList() as M;
		}
		if(<CountryData>[] is M){
			return data.map<CountryData>((Map<String, dynamic> e) => CountryData.fromJson(e)).toList() as M;
		}
		if(<CountryList>[] is M){
			return data.map<CountryList>((Map<String, dynamic> e) => CountryList.fromJson(e)).toList() as M;
		}
		if(<FeedbackList>[] is M){
			return data.map<FeedbackList>((Map<String, dynamic> e) => FeedbackList.fromJson(e)).toList() as M;
		}
		if(<FeedbackFulldata>[] is M){
			return data.map<FeedbackFulldata>((Map<String, dynamic> e) => FeedbackFulldata.fromJson(e)).toList() as M;
		}
		if(<Head>[] is M){
			return data.map<Head>((Map<String, dynamic> e) => Head.fromJson(e)).toList() as M;
		}
		if(<InvoiceData>[] is M){
			return data.map<InvoiceData>((Map<String, dynamic> e) => InvoiceData.fromJson(e)).toList() as M;
		}
		if(<Message>[] is M){
			return data.map<Message>((Map<String, dynamic> e) => Message.fromJson(e)).toList() as M;
		}
		if(<MessageData>[] is M){
			return data.map<MessageData>((Map<String, dynamic> e) => MessageData.fromJson(e)).toList() as M;
		}
		if(<NetworkDashboard>[] is M){
			return data.map<NetworkDashboard>((Map<String, dynamic> e) => NetworkDashboard.fromJson(e)).toList() as M;
		}
		if(<NetWorkDashboardData>[] is M){
			return data.map<NetWorkDashboardData>((Map<String, dynamic> e) => NetWorkDashboardData.fromJson(e)).toList() as M;
		}
		if(<NetworkSlider>[] is M){
			return data.map<NetworkSlider>((Map<String, dynamic> e) => NetworkSlider.fromJson(e)).toList() as M;
		}
		if(<NetworkSliderData>[] is M){
			return data.map<NetworkSliderData>((Map<String, dynamic> e) => NetworkSliderData.fromJson(e)).toList() as M;
		}
		if(<NotificationMessage>[] is M){
			return data.map<NotificationMessage>((Map<String, dynamic> e) => NotificationMessage.fromJson(e)).toList() as M;
		}
		if(<Profile>[] is M){
			return data.map<Profile>((Map<String, dynamic> e) => Profile.fromJson(e)).toList() as M;
		}
		if(<Profiledata>[] is M){
			return data.map<Profiledata>((Map<String, dynamic> e) => Profiledata.fromJson(e)).toList() as M;
		}
		if(<RemindDateofAsset>[] is M){
			return data.map<RemindDateofAsset>((Map<String, dynamic> e) => RemindDateofAsset.fromJson(e)).toList() as M;
		}
		if(<ResultInfo>[] is M){
			return data.map<ResultInfo>((Map<String, dynamic> e) => ResultInfo.fromJson(e)).toList() as M;
		}
		if(<Salesinfo>[] is M){
			return data.map<Salesinfo>((Map<String, dynamic> e) => Salesinfo.fromJson(e)).toList() as M;
		}
		if(<SalesinfoData>[] is M){
			return data.map<SalesinfoData>((Map<String, dynamic> e) => SalesinfoData.fromJson(e)).toList() as M;
		}
		if(<SettingsData>[] is M){
			return data.map<SettingsData>((Map<String, dynamic> e) => SettingsData.fromJson(e)).toList() as M;
		}
		if(<ShareSlider>[] is M){
			return data.map<ShareSlider>((Map<String, dynamic> e) => ShareSlider.fromJson(e)).toList() as M;
		}
		if(<ShareSliderData>[] is M){
			return data.map<ShareSliderData>((Map<String, dynamic> e) => ShareSliderData.fromJson(e)).toList() as M;
		}
		if(<StateData>[] is M){
			return data.map<StateData>((Map<String, dynamic> e) => StateData.fromJson(e)).toList() as M;
		}
		if(<Statelist>[] is M){
			return data.map<Statelist>((Map<String, dynamic> e) => Statelist.fromJson(e)).toList() as M;
		}
		if(<Tokendata>[] is M){
			return data.map<Tokendata>((Map<String, dynamic> e) => Tokendata.fromJson(e)).toList() as M;
		}
		if(<BillEntity>[] is M){
			return data.map<BillEntity>((Map<String, dynamic> e) => BillEntity.fromJson(e)).toList() as M;
		}
		if(<BillData>[] is M){
			return data.map<BillData>((Map<String, dynamic> e) => BillData.fromJson(e)).toList() as M;
		}
		if(<CountrySingleDataEntity>[] is M){
			return data.map<CountrySingleDataEntity>((Map<String, dynamic> e) => CountrySingleDataEntity.fromJson(e)).toList() as M;
		}
		if(<CountrySingleDataData>[] is M){
			return data.map<CountrySingleDataData>((Map<String, dynamic> e) => CountrySingleDataData.fromJson(e)).toList() as M;
		}
		if(<CouponDataEntity>[] is M){
			return data.map<CouponDataEntity>((Map<String, dynamic> e) => CouponDataEntity.fromJson(e)).toList() as M;
		}
		if(<CouponDataData>[] is M){
			return data.map<CouponDataData>((Map<String, dynamic> e) => CouponDataData.fromJson(e)).toList() as M;
		}

		debugPrint("${M.toString()} not found");
	
		return null;
}

	static M? fromJsonAsT<M>(dynamic json) {
		if (json is List) {
			return _getListChildType<M>(json.map((e) => e as Map<String, dynamic>).toList());
		} else {
			return jsonConvert.asT<M>(json);
		}
	}
}